<?php 
/**
 * @package MG Web Speed Optimization
 * @version 1.0
 */
/*
Plugin Name: MG Web Speed Optimization
Plugin URI: http:/wordpress.org/plugins/MgWebOptimization
Description: MagentoGems Web Speed Optimizer enhanced websites speed with out effecting database ad core files. MG(MagentoGems) Web Speed Optimizer has capability to optimize your website and provide 85+ Rank in Google insight and Yslow. 
This plugin has no effect on database and very secure to install. This Plugin will Optimize your Images, JavaScript and CSS to use Gzip compression 
in your website and reduce the loading time of your website. This is fully tested on 3.4 to 4.0 version of wordpress. 
Author: <a href="http://magentogems.com/about-us">Zahid Mughal</a>
version 1.0
*/  
// This wil Run the installer of the Plugin and will insert the Optimize string in the .htaccess file
register_activation_hook( __FILE__, 'Mg_install' );
function Mg_install() {
	$code_d='#ie2t
	
	Header unset ETag
	FileETag None
	
	# Hantera och redirecta användare till en gemensam error-sia
	
	# BEGIN Compress text files 
	<ifModule mod_deflate.c>
	  <filesMatch "\.(css|js|x?html?|php)$">
	    SetOutputFilter DEFLATE
	  </filesMatch>
	</ifModule>
	# END Compress text files 
	
	# BEGIN Expire headers 
	<IfModule mod_expires.c>
	ExpiresActive On
	<FilesMatch "\.(ico|pdf|flv|jpg|jpeg|png|gif|js|css|swf|form)$">
	ExpiresDefault "access plus 1 year"
	</FilesMatch>
	</IfModule>
	# END Expire headers 
	
	# BEGIN Cache-Control Headers 
	<ifModule mod_headers.c>
	  <filesMatch "\.(ico|jpe?g|png|gif|swf)$">
	    Header set Cache-Control "max-age=2592000, public"
	  </filesMatch>
	  <filesMatch "\.(css)$">
	    Header set Cache-Control "max-age=604800, public"
	  </filesMatch>
	  <filesMatch "\.(js)$">
	    Header set Cache-Control "max-age=216000, private"
	  </filesMatch>
	  <filesMatch "\.(x?html?|php)$">
	    Header set Cache-Control "max-age=600, private, must-revalidate"
	  </filesMatch>
	</ifModule>
	# END Cache-Control Headers 
	
	# BEGIN Turn ETags Off 
	<ifModule mod_headers.c>
	  Header unset ETag
	</ifModule>
	FileETag None
	# END Turn ETags Off 
	
	# BEGIN Remove Last-Modified Header 
	<ifModule mod_headers.c>
	  Header unset Last-Modified
	</ifModule>
	# END Remove Last-Modified Header
	
	# BEGIN Gzip Compression
	<ifModule mod_gzip.c>
	  mod_gzip_on Yes
	  mod_gzip_dechunk Yes
	  mod_gzip_item_include file \.(html?|txt|css|js|php|pl)$
	  mod_gzip_item_include handler ^cgi-script$
	  mod_gzip_item_include mime ^text/.*
	  mod_gzip_item_include mime ^application/x-javascript.*
	  mod_gzip_item_exclude mime ^image/.*
	  mod_gzip_item_exclude rspheader ^Content-Encoding:.*gzip.*
	</ifModule>
	# END Gzip Compression
	
	AddDefaultCharset UTF-8
	DefaultLanguage sv-SE
	
	# Force “File Save As” Prompt
	AddType application/octet-stream .avi .mpg .mov .pdf .xls .mp4 .rar';	

	//$dir_root = "http://".$_SERVER['HTTP_HOST'].'/'.'.htaccess';
	$dir_root = dirname(dirname(dirname(dirname(__FILE__))));
	if(@file_exists($dir_root.'/.htaccess')){
		if (is_writeable($dir_root.'/.htaccess')){
			$myfile= fopen($dir_root.'/.htaccess',"a+");
			fwrite($myfile,$code_d);
			fclose($myfile);
		}else{
			die('Please change .htaccess File permission to 777 and Click Activate Again !');
		}
	}
	else {
		$myfile= fopen($dir_root.'/.htaccess',"w");
		fwrite($myfile,$code_d);
		fclose($myfile);
	}
}

/*
	From here Disable Plugin Installer will Run and it will remove the Optimize String from the .htaccess file. This will
	This will Also check the Permission of the file as well.
*/	
register_deactivation_hook(__FILE__,'Mg_pluginUninstall');
 function Mg_pluginUninstall() {
	$code_d='#ie2t
	
	Header unset ETag
	FileETag None
	
	# Hantera och redirecta användare till en gemensam error-sia
	
	# BEGIN Compress text files 
	<ifModule mod_deflate.c>
	  <filesMatch "\.(css|js|x?html?|php)$">
	    SetOutputFilter DEFLATE
	  </filesMatch>
	</ifModule>
	# END Compress text files 
	
	# BEGIN Expire headers 
	<IfModule mod_expires.c>
	ExpiresActive On
	<FilesMatch "\.(ico|pdf|flv|jpg|jpeg|png|gif|js|css|swf|form)$">
	ExpiresDefault "access plus 1 year"
	</FilesMatch>
	</IfModule>
	# END Expire headers 
	
	# BEGIN Cache-Control Headers 
	<ifModule mod_headers.c>
	  <filesMatch "\.(ico|jpe?g|png|gif|swf)$">
	    Header set Cache-Control "max-age=2592000, public"
	  </filesMatch>
	  <filesMatch "\.(css)$">
	    Header set Cache-Control "max-age=604800, public"
	  </filesMatch>
	  <filesMatch "\.(js)$">
	    Header set Cache-Control "max-age=216000, private"
	  </filesMatch>
	  <filesMatch "\.(x?html?|php)$">
	    Header set Cache-Control "max-age=600, private, must-revalidate"
	  </filesMatch>
	</ifModule>
	# END Cache-Control Headers 
	
	# BEGIN Turn ETags Off 
	<ifModule mod_headers.c>
	  Header unset ETag
	</ifModule>
	FileETag None
	# END Turn ETags Off 
	
	# BEGIN Remove Last-Modified Header 
	<ifModule mod_headers.c>
	  Header unset Last-Modified
	</ifModule>
	# END Remove Last-Modified Header
	
	# BEGIN Gzip Compression
	<ifModule mod_gzip.c>
	  mod_gzip_on Yes
	  mod_gzip_dechunk Yes
	  mod_gzip_item_include file \.(html?|txt|css|js|php|pl)$
	  mod_gzip_item_include handler ^cgi-script$
	  mod_gzip_item_include mime ^text/.*
	  mod_gzip_item_include mime ^application/x-javascript.*
	  mod_gzip_item_exclude mime ^image/.*
	  mod_gzip_item_exclude rspheader ^Content-Encoding:.*gzip.*
	</ifModule>
	# END Gzip Compression
	
	AddDefaultCharset UTF-8
	DefaultLanguage sv-SE
	
	# Force “File Save As” Prompt
	AddType application/octet-stream .avi .mpg .mov .pdf .xls .mp4 .rar';	
	
	/*
		To Find the .htaccess on Root of the server. If it exist then we will check the
		Permissions here as well. This will create a new file in case of file not found and will place the code to optimize the website
	*/
	$dir_root = dirname(dirname(dirname(dirname(__FILE__))));
	if(file_exists($dir_root.'/.htaccess')){
		if (is_writeable($dir_root.'/.htaccess')){
			$FileContent = file_get_contents($dir_root.'/.htaccess');
			$FileContent=str_replace($code_d,'',$FileContent);
			file_put_contents($dir_root.'/.htaccess', $FileContent);
		}else{
			die('Please change .htaccess File permission to 777 and Press Deactivate Link Again...');
		} 
	}
}
?>